/*****************************************************************************

  Licensed to Accellera Systems Initiative Inc. (Accellera) under one or
  more contributor license agreements.  See the NOTICE file distributed
  with this work for additional information regarding copyright ownership.
  Accellera licenses this file to you under the Apache License, Version 2.0
  (the "License"); you may not use this file except in compliance with the
  License.  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
  implied.  See the License for the specific language governing
  permissions and limitations under the License.

 *****************************************************************************/

/*****************************************************************************

  testbench.h -- 

  Original Author: Martin Janssen, Synopsys, Inc., 2002-02-15

 *****************************************************************************/

/*****************************************************************************

  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.

      Name, Affiliation, Date:
  Description of Modification:

 *****************************************************************************/

/* Filename testbench.h */
/* This is the interface file for synchronous process 'testbench' */

#include "systemc.h"

SC_MODULE( testbench )
{

  sc_in_clk clk;

  sc_in<bool>  q;
  sc_in<bool>  qp;
  sc_out<bool> s;
  sc_out<bool> r;

  // Constructor 
  testbench( sc_module_name NAME,
	     sc_clock& CLK,
	     sc_signal<bool>& Q,
	     sc_signal<bool>& QP,
	     sc_signal<bool>& S,
	     sc_signal<bool>& R )
  {
    clk(CLK);
    q(Q); qp(QP); s(S); r(R);
	SC_CTHREAD( entry, clk.pos() );
  }

  // Process functionality in member function below
  void entry();
};

